/*****************************************************************************
 *	axcpi01s.c
 *
 *	AXC-PI01
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date Jun.2003
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
/*****************************************************************************/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "axcpi01w.h"

#define WM_AXCPI01			( WM_USER + 100 )

static void ResultMessage( LPCTSTR lpszbuf );
static void ErrorMessage( WORD wLogSocket );

BOOL	OnCreate( HWND hWnd );
BOOL	OnDestroy( void );
BOOL	OnInterrupt( WPARAM wParam );
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

const TCHAR szTitle[] = _T("Sample");
const TCHAR szPI01[] = _T("AXC-PI01");
TCHAR		szbuf[1024];
WORD		wLogSocket;					// foCXi[
TCHAR		szClassName[] = _T(" ۸");

/*===================================================================
// C
//=================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
										LPWSTR lpCmdLine, int nCmdShow)
{
	MSG			msg;
	WNDCLASS	wc;
	HWND		hWnd;

	/*---------------------------------------------------------------
	// EChENXo^
	//-------------------------------------------------------------*/
	if (!hPrevInstance) {
		wc.style			= CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc		= WndProc;
		wc.cbClsExtra		= 0;
		wc.cbWndExtra		= 0;
		wc.hInstance		= hInstance;
		wc.hIcon			= NULL;
		wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground	= GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName		= NULL;
		wc.lpszClassName	= szClassName;
		if (!RegisterClass(&wc)) return FALSE;
	}
	/*---------------------------------------------------------------
	// EChE쐬
	//-------------------------------------------------------------*/
	hWnd = CreateWindow(szClassName,
		szPI01,
		WS_VISIBLE,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInstance,
		NULL);

	if ( hWnd == NULL ) return FALSE;
	/*---------------------------------------------------------------
	// EChE\
	//-------------------------------------------------------------*/
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	//---------------------------------------------------------------
	// bZ[W[v
	//---------------------------------------------------------------
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);
}
/*===================================================================
// EChEbZ[W
//=================================================================*/
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {

		case WM_CREATE:
			OnCreate(hWnd);
			break;

		case WM_AXCPI01 + AXCPI01_WM_OFS_CARD_REMOVAL:
			ResultMessage( TEXT("ނ܂") );
			OnDestroy();
			PostQuitMessage(0);
			break;

		case WM_AXCPI01 + AXCPI01_WM_OFS_IN:
			OnInterrupt( wParam );
			break;

		case WM_DESTROY:
			OnDestroy();
			PostQuitMessage(0);
			break;

		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return 0;
}
//===================================================================
// ͊荞ݔɑ΂鏈
//===================================================================
BOOL OnInterrupt( WPARAM wParam )
{
	int	iIRQ;

	/*-----------------------------------------------------------------
		荞ݔbZ[W\
	-----------------------------------------------------------------*/
    // wParam̉8rbg}XN
    // 8rbgF@荞݃Xe[^X
	iIRQ = wParam & 0x00FF;

	switch ( iIRQ ) {
	
		case 0x01:
			ResultMessage( _T("IRQ1荞݂܂B\n") );
			break;

		case 0x02:
			ResultMessage( _T("IRQ2荞݂܂B\n") );
			break;

		case 0x03:
			ResultMessage( _T("IRQ1,IRQ2荞݂܂B\n") );
			break;

		default:
			break;

	}

	OnDestroy();
	PostQuitMessage(0);

	return TRUE;
}
//===================================================================
// ckkJ
//===================================================================
BOOL OnDestroy( void )
{
	/*=================================================================
	 * AXP-AXCPI01 J
	 *===============================================================*/
	Axcpi01wClose( wLogSocket );
	wsprintf( szbuf,
		_T("޲۰\n\n")
		_T("LogSocket: %d"), wLogSocket );
	ResultMessage(szbuf);
	/*=================================================================
	 * Axcpi01.dll J
	 *===============================================================*/
	if (Axcpi01wDllClose() == FALSE) {
		ErrorMessage(AXCPI01_SOCKET_AUTO);
		return FALSE;			/* axpad02.dll ̃A[hɎs܂B */
	}

	return TRUE;
}
//===================================================================
// ckk[h犄荞݋܂ł̏
//===================================================================
BOOL OnCreate( HWND hWnd )
{
	DWORD	dwDLLVer, dwDrvVer;
	BOOL	bResult;						// 
	DWORD	dwIOPortBase;
	DWORD	dwIOPortLength;
	BYTE	Value;

	/*=================================================================
	 * Axcpi01.dll ̎gp錾
	 *===============================================================*/
	if ( Axcpi01wDllOpen() == FALSE ) {
		ErrorMessage(AXCPI01_SOCKET_AUTO);
		return FALSE;						// axpad02.dll ̃[hɎs܂
	}
	/*=================================================================
	 * o[W̎擾
	 *===============================================================*/
	if (Axcpi01wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE) {
		ErrorMessage(AXCPI01_SOCKET_AUTO);
		return FALSE;
	}
	wsprintf(szbuf, _T("ްޮݏ\n") _T("DLL Version:    %08lxh\n")
							_T("Driver Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);
	/*=================================================================
	 * AXC-PI01 ̎gp錾
	 *===============================================================*/
	wLogSocket = AXCPI01_SOCKET_AUTO;			/* gp̃foCX */
	bResult = Axcpi01wCreate( &wLogSocket, hWnd, WM_AXCPI01, NULL );
	if (bResult == FALSE) {						/* foCX܂B */
		ErrorMessage(AXCPI01_SOCKET_AUTO);
		return FALSE;
	}
	wsprintf(szbuf, _T("޲\n\n") _T("LogSocket: %2d\n"), wLogSocket);
	ResultMessage(szbuf);
	/*=================================================================
	 * \[X擾
	 *===============================================================*/
	if (Axcpi01wGetResource( wLogSocket, &dwIOPortBase, &dwIOPortLength ) == FALSE) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf(szbuf, _T("ؿ\n\n")
					_T("IO Address : %08xh-%08xh\n") ,
					dwIOPortBase,
					dwIOPortBase + dwIOPortLength - 1 );
	ResultMessage(szbuf);
	/*=================================================================
	 * eWX^̐ݒ
	 * (WX^̏ڍׂɂẮAn[hEFÃ}jAQƂB)
	 *===============================================================*/
	/*-----------------------------------------------------------------
		D0`D7rbgo͂ɐݒ肵A
		D8`D13rbg͂ɐݒ肷
		uI/O Select RegistervɃf[^uFF00hv[ho͂
	-----------------------------------------------------------------*/
	if ( Axcpi01wOutPortW( wLogSocket, AXCPI01_PORT_IO_SELECT_L, 0xFF00 ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf( szbuf,
		_T("uI/O Select Registerv\n")
		_T(" 0xFF00 ܰޏo͂܂B\n\n")
		_T("D0`D7   : o\n")
		_T("D8`D13 : ") );
	ResultMessage(szbuf);
	/*-----------------------------------------------------------------
		D0rbgOpenDraino͂ɐݒ肷
		uPU/PD Select RegistervɃf[^uFEhv޲ďo͂
	-----------------------------------------------------------------*/
	if ( Axcpi01wOutPortB( wLogSocket, AXCPI01_PORT_OUTPUT_MODE_L, 0xFE ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf( szbuf,
		_T("uOutput Mode Registerv\n")
		_T(" 0xFE ޲ďo͂܂B\n\n")
		_T("D0 : OpenDraino") );
	ResultMessage(szbuf);
	/*-----------------------------------------------------------------
		D0rbgPull Downɐݒ肷
		uPU/PD Select RegistervɃf[^uFDhvoCgo͂
	-----------------------------------------------------------------*/
	if ( Axcpi01wOutPortB( wLogSocket, AXCPI01_PORT_PUPD_SELECT_L, 0xFD ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf( szbuf,
		_T("uPU/PD Select Registerv\n")
		_T(" 0xFD ޲ďo͂܂B\n\n")
		_T("D1 : Pull Down") );
	ResultMessage(szbuf);
	/*-----------------------------------------------------------------
		荞݋֎~ݒ
		uIRQ Registerv̉ʃoCgɃf[^u0FhvoCgo͂
	-----------------------------------------------------------------*/
	if ( Axcpi01wOutPortB( wLogSocket, AXCPI01_PORT_IRQ_L, 0xF ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf( szbuf,
		_T("uIRQ Registerv\n")
		_T(" 0x0F ޲ďo͂܂B\n\n")
		_T("IRQ1,IRQ2: 荞݋֎~") );
	ResultMessage(szbuf);
	/*-----------------------------------------------------------------
		uData RegistervD0`D7rbgɁuAAHvoCgo͂
	-----------------------------------------------------------------*/
	if ( Axcpi01wOutPortB( wLogSocket, AXCPI01_PORT_DATA_L, 0xAA ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf( szbuf,
		_T("uData Registerv\n")
		_T(" 0xAA ܰޏo͂܂B\n\n")
		_T("D0`D7o : 0xAA") );
	ResultMessage(szbuf);
	/*-----------------------------------------------------------------
		uData RegistervD8`D13rbgoCg͂
	-----------------------------------------------------------------*/
	if ( Axcpi01wInPortB( wLogSocket, AXCPI01_PORT_DATA_H, &Value ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf( szbuf,
		_T("uData Registerv\n")
		_T("D8`D13ޯĂ\n")
		_T(" ޲ē͂܂B\n\n")
		_T("D8`D13 : 0x%02x"), Value );
	ResultMessage(szbuf);
	/*-----------------------------------------------------------------
		IRQ1荞݋ݒ
		uIRQ Registerv̉ʃoCgɃf[^u0EhvoCgo͂
	-----------------------------------------------------------------*/
	if ( Axcpi01wOutPortB( wLogSocket, AXCPI01_PORT_IRQ_L, 0xE ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return FALSE;
	}
	wsprintf( szbuf,
		_T("uIRQ Registerv\n")
		_T(" 0x0E ޲ďo͂܂B\n\n")
		_T("IRQ1: 荞݋") );
	ResultMessage(szbuf);

	return TRUE;
}
/*-------------------------------------------------------------------
// ʂ\
//-----------------------------------------------------------------*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szPI01, MB_OK | MB_ICONINFORMATION);
}
/*-------------------------------------------------------------------
// G[bZ[W\ďI
//-----------------------------------------------------------------*/
static void ErrorMessage(WORD wLogSocket)
{
	DWORD dwRes = Axcpi01wGetLastError(wLogSocket);
	TCHAR szbuf[50];

	switch (dwRes) {
		case AXCPI01_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"), GetLastError());
			break;

		case AXCPI01_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("AXC-PI01 error\n\n")
							_T("Error code: %08lxh"), dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
