/*****************************************************************************
 * Axcpi01w.c
 *
 * AXC-PI01
 * Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 * Date Jun.2007
/*****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "axcpi01w.h"
//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Axcpi01wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAxcpi01GetVersion;
static FARPROC pAxcpi01Create;
static FARPROC pAxcpi01Close;
static FARPROC pAxcpi01GetResource;
static FARPROC pAxcpi01InPortB;
static FARPROC pAxcpi01OutPortB;
static FARPROC pAxcpi01InPortW;
static FARPROC pAxcpi01OutPortW;
static FARPROC pAxcpi01GetIRQStatus;
static FARPROC pAxcpi01GetLastError;

BOOL Axcpi01wDllOpen ( void )
/*****************************************************************************
 * @\  axcpi01w.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AXCPI01_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Axcpi01wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Axcpi01wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Axcpi01wDllClose ( void )
/*****************************************************************************
 * @\  axcpi01w.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Axcpi01wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  AXC-PI01DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Axcpi01wCreate ( PWORD pwLogSocket, HWND hWnd, UINT uWMBase, PVOID pvInitArg )
/*****************************************************************************
 * @\  AXC-PI01̔Cӂ̃foCX̎gp錾
 * 	 pwLogSocket	--- gpfoCXi[AhX
 *		 hWnd		--- bZ[W󂯂EChEnh
 *		 uWMBase	--- bZ[Whc̃x[X
 *		 pvInitArg	--- \
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01Create)(pwLogSocket, hWnd, uWMBase, pvInitArg);
}

BOOL Axcpi01wClose ( WORD wLogSocket )
/*****************************************************************************
 * @\  AXC-PI01̔Cӂ̃foCX̎gpJ
 * 	 wLogSocket  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01Close)(wLogSocket);
}

BOOL Axcpi01wGetResource ( WORD wLogSocket, PDWORD pdwIOPortBase, PDWORD pdwIOPortLength )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSocket      --- ׂfoCX
 *		 pdwIOPortBase   --- I/Ox[XAhXi[\̂̃AhX
 *		 pdwIOPortLength --- I/OAhXi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01GetResource)(wLogSocket, pdwIOPortBase, pdwIOPortLength);
}

BOOL Axcpi01wInPortB (WORD wLogSocket, DWORD dwPort, PBYTE pbValue )
/*****************************************************************************
 * @\  e|[gɑ΂PoCg
 * 	 wLogSocket --- foCX
 *		 pbValue	--- 擾li[̈̃|C^
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01InPortB)(wLogSocket,dwPort,pbValue);
}

BOOL Axcpi01wOutPortB (WORD wLogSocket, DWORD dwPort, BYTE bValue )
/*****************************************************************************
 * @\  e|[gɑ΂oCgo
 * 	 wLogSocket --- foCX
 *		 bValue 	--- o͂l
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01OutPortB)(wLogSocket,dwPort,bValue);
}

BOOL Axcpi01wInPortW (WORD wLogSocket, DWORD dwPort, PWORD pwValue )
/*****************************************************************************
 * @\  e|[gɑ΂P[h
 * 	 wLogSocket --- foCX
 *		 pwValue	--- 擾li[̈̃|C^
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01InPortW)(wLogSocket,dwPort,pwValue);
}

BOOL Axcpi01wOutPortW (WORD wLogSocket, DWORD dwPort, WORD wValue )
/*****************************************************************************
 * @\  e|[gɑ΂[ho
 * 	 wLogSocket --- foCX
 *		 wValue 	--- o͂l
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01OutPortW)(wLogSocket,dwPort,wValue);
}

BOOL Axcpi01wGetIRQStatus ( WORD wLogSocket, PBYTE pbStatus )
/*****************************************************************************
 * @\  wfoCX̊荞݃Xe[^X擾
 * 	 wLogSocket   --- ׂfoCX
 *		 pbStatus     --- 荞݃Xe[^Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpi01GetIRQStatus)(wLogSocket, pbStatus);
}


DWORD Axcpi01wGetLastError( WORD wLogSocket )
/*****************************************************************************
 * @\  G[R[h擾
 * 	 wLogSocket --- ΏۃfoCX
 * ߒl	 G[R[h
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AXCPI01_ERR_WRAPDLL;
	}
	return (*pAxcpi01GetLastError)(wLogSocket);
}

static BOOL Axcpi01wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Axcpi01GetVersion ̃AhX擾
	pAxcpi01GetVersion = GetProcAddress(hDLL, _T("Axcpi01GetVersion"));
	if (pAxcpi01GetVersion == NULL) return FALSE;

	// Axcpi01Create ̃AhX擾
	pAxcpi01Create = GetProcAddress(hDLL, _T("Axcpi01Create"));
	if (pAxcpi01Create == NULL) return FALSE;

	// Axcpi01Close ̃AhX擾
	pAxcpi01Close = GetProcAddress(hDLL, _T("Axcpi01Close"));
	if (pAxcpi01Close == NULL) return FALSE;

	// Axcpi01GetResource ̃AhX擾
	pAxcpi01GetResource = GetProcAddress(hDLL, _T("Axcpi01GetResource"));
	if ( pAxcpi01GetResource == NULL ) return FALSE;

	// Axcpi01InPortB ̃AhX擾
	pAxcpi01InPortB = GetProcAddress(hDLL, _T("Axcpi01InPortB"));
	if ( pAxcpi01InPortB == NULL ) return FALSE;

	// Axcpi01OutPortB ̃AhX擾
	pAxcpi01OutPortB = GetProcAddress(hDLL, _T("Axcpi01OutPortB"));
	if ( pAxcpi01OutPortB == NULL ) return FALSE;

	// Axcpi01InPortW ̃AhX擾
	pAxcpi01InPortW = GetProcAddress(hDLL, _T("Axcpi01InPortW"));
	if ( pAxcpi01InPortW == NULL ) return FALSE;

	// Axcpi01OutPortW ̃AhX擾
	pAxcpi01OutPortW = GetProcAddress(hDLL, _T("Axcpi01OutPortW"));
	if ( pAxcpi01OutPortW == NULL ) return FALSE;

	// Axcpi01GetIRQStatus ̃AhX擾
	pAxcpi01GetIRQStatus = GetProcAddress(hDLL, _T("Axcpi01GetIRQStatus"));
	if ( pAxcpi01GetResource == NULL ) return FALSE;

	// Axcpi01GetLastError ̃AhX擾
	pAxcpi01GetLastError = GetProcAddress(hDLL, _T("Axcpi01GetLastError"));
	if ( pAxcpi01GetLastError == NULL ) {
		return FALSE;
	}

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
